from django.shortcuts import redirect
# middleware.py
from django.http import HttpResponsePermanentRedirect



class RedirectToNonWWW(object):
    def __init__(self, get_response):
        self.get_response = get_response

    def __call__(self, request):
        host = request.get_host()
        if host.startswith('www.'):
            new_url = request.build_absolute_uri().replace('://www.', '://', 1)
            return HttpResponsePermanentRedirect(new_url)
        else:
            return self.get_response(request)



class InvalidURLMiddleware:
    def __init__(self, get_response):
        self.get_response = get_response

    def __call__(self, request):
        response = self.get_response(request)

        # Check if the requested URL is invalid (you can define your logic here)
        if not is_valid_url(request.path):
            return redirect('home')  # Redirect to the home page

        return response

def is_valid_url(url):
    # Implement your URL validation logic here
    # You can use regular expressions or any other method to check if the URL is valid
    # For this example, let's assume any URL starting with '/tag/' is considered invalid
    return not url.startswith('/tag/')
